Index: package_tags/invirt-dns/0.0.1/debian/changelog
===================================================================
--- package_tags/invirt-dns/0.0.1/debian/changelog	(revision 1186)
+++ package_tags/invirt-dns/0.0.1/debian/changelog	(revision 1186)
@@ -0,0 +1,56 @@
+invirt-dns (0.0.1) unstable; urgency=low
+
+  * sipb-xen -> invirt
+
+ -- Greg Price <price@mit.edu>  Fri, 24 Oct 2008 00:54:52 -0400
+
+sipb-xen-dns (1.06) unstable; urgency=low
+
+  * Fix the SQLAlchemy calls
+
+ -- Evan Broder <broder@mit.edu>  Fri, 03 Oct 2008 20:44:23 -0400
+
+sipb-xen-dns (1.05.1) unstable; urgency=low
+
+  * Include the requirement on twisted.names
+
+ -- Evan Broder <broder@mit.edu>  Thu, 02 Oct 2008 18:48:58 -0400
+
+sipb-xen-dns (1.05) unstable; urgency=low
+
+  * Convert package to not include a svn checkout in the binary package
+
+ -- Evan Broder <broder@mit.edu>  Thu, 02 Oct 2008 18:41:25 -0400
+
+sipb-xen-dns (1.04) unstable; urgency=low
+
+  * Search for longest-matching domain name instead of first-matching.
+  * ns1.prod.xvm.mit.edu (0.0.0.0) is the primary nameserver for the prod
+    zone.
+
+ -- Yang Zhang <y_z@mit.edu>  Mon, 25 Aug 2008 01:01:17 -0400
+
+sipb-xen-dns (1.03) unstable; urgency=low
+
+  * debian/
+
+ -- Yang Zhang <y_z@mit.edu>  Sun, 24 Aug 2008 16:37:16 -0400
+
+sipb-xen-dns (1.02) unstable; urgency=low
+
+  * sipb_xen_database -> invirt.database
+  * use invirt.config in dnsserver.py
+
+ -- Yang Zhang <y_z@mit.edu>  Sun,  3 Aug 2008 19:18:40 -0400
+
+sipb-xen-dns (1.01) unstable; urgency=low
+
+  * update SOA record for the xvm.mit.edu order of things
+
+ -- Greg Price <price@mit.edu>  Sun,  3 Aug 2008 02:10:03 -0400
+
+sipb-xen-dns (1) unstable; urgency=low
+
+  * Initial Release.
+ -- SIPB Xen Project <sipb-xen@mit.edu>  Sun, 24 Feb 2008 20:45:28 -0500
+
Index: package_tags/invirt-dns/0.0.1/debian/compat
===================================================================
--- package_tags/invirt-dns/0.0.1/debian/compat	(revision 1186)
+++ package_tags/invirt-dns/0.0.1/debian/compat	(revision 1186)
@@ -0,0 +1,1 @@
+4
Index: package_tags/invirt-dns/0.0.1/debian/control
===================================================================
--- package_tags/invirt-dns/0.0.1/debian/control	(revision 1186)
+++ package_tags/invirt-dns/0.0.1/debian/control	(revision 1186)
@@ -0,0 +1,11 @@
+Source: invirt-dns
+Section: base
+Priority: extra
+Maintainer: Invirt Project <invirt@mit.edu>
+Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 4.1.0), subversion
+Standards-Version: 3.7.2
+
+Package: invirt-dns
+Architecture: all
+Depends: ${misc:Depends}, daemon, python-twisted-names
+Description: Install and enable the DNS server
Index: package_tags/invirt-dns/0.0.1/debian/copyright
===================================================================
--- package_tags/invirt-dns/0.0.1/debian/copyright	(revision 1186)
+++ package_tags/invirt-dns/0.0.1/debian/copyright	(revision 1186)
@@ -0,0 +1,3 @@
+This package was created for internal use of the SIPB Xen Project of
+the MIT Student Information Processing Board.  Ask invirt@mit.edu if
+you have questions about redistribution.
Index: package_tags/invirt-dns/0.0.1/debian/invirt-dns.init
===================================================================
--- package_tags/invirt-dns/0.0.1/debian/invirt-dns.init	(revision 1186)
+++ package_tags/invirt-dns/0.0.1/debian/invirt-dns.init	(revision 1186)
@@ -0,0 +1,124 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides:          invirt-dns
+# Required-Start:    $local_fs $remote_fs
+# Required-Stop:     $local_fs $remote_fs
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Invirt DNS server
+# Description:       
+### END INIT INFO
+
+# Author: Invirt Project <invirt@mit.edu>
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="the Invirt DNS server"
+NAME=invirt-dns
+DAEMON=/usr/sbin/invirt-dns
+DAEMON_ARGS=""
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+	# Return
+	#   0 if daemon has been started
+	#   1 if daemon was already running
+	#   2 if daemon could not be started
+	daemon --running -n $NAME && return 1
+	daemon -r -O daemon.info -E daemon.err -n $NAME -U $DAEMON $DAEMON_ARGS || return 2
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+	# Return
+	#   0 if daemon has been stopped
+	#   1 if daemon was already stopped
+	#   2 if daemon could not be stopped
+	#   other if a failure occurred
+	daemon --stop -n $NAME
+	RETVAL="$?"
+	[ "$RETVAL" = 2 ] && return 2
+	# Many daemons don't delete their pidfiles when they exit.
+	rm -f $PIDFILE
+	return "$RETVAL"
+}
+
+case "$1" in
+  start)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+	do_start
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  stop)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+	do_stop
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  #reload|force-reload)
+	#
+	# If do_reload() is not implemented then leave this commented out
+	# and leave 'force-reload' as an alias for 'restart'.
+	#
+	#log_daemon_msg "Reloading $DESC" "$NAME"
+	#do_reload
+	#log_end_msg $?
+	#;;
+  restart|force-reload)
+	#
+	# If the "reload" option is implemented then remove the
+	# 'force-reload' alias
+	#
+	log_daemon_msg "Restarting $DESC" "$NAME"
+	do_stop
+	case "$?" in
+	  0|1)
+		do_start
+		case "$?" in
+			0) log_end_msg 0 ;;
+			1) log_end_msg 1 ;; # Old process is still running
+			*) log_end_msg 1 ;; # Failed to start
+		esac
+		;;
+	  *)
+	  	# Failed to stop
+		log_end_msg 1
+		;;
+	esac
+	;;
+  *)
+	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
+	exit 3
+	;;
+esac
+
+:
Index: package_tags/invirt-dns/0.0.1/debian/invirt-dns.install
===================================================================
--- package_tags/invirt-dns/0.0.1/debian/invirt-dns.install	(revision 1186)
+++ package_tags/invirt-dns/0.0.1/debian/invirt-dns.install	(revision 1186)
@@ -0,0 +1,1 @@
+files/* .
Index: package_tags/invirt-dns/0.0.1/debian/rules
===================================================================
--- package_tags/invirt-dns/0.0.1/debian/rules	(revision 1186)
+++ package_tags/invirt-dns/0.0.1/debian/rules	(revision 1186)
@@ -0,0 +1,3 @@
+#!/usr/bin/make -f
+
+include /usr/share/cdbs/1/rules/debhelper.mk
Index: package_tags/invirt-dns/0.0.1/files/usr/sbin/invirt-dns
===================================================================
--- package_tags/invirt-dns/0.0.1/files/usr/sbin/invirt-dns	(revision 1186)
+++ package_tags/invirt-dns/0.0.1/files/usr/sbin/invirt-dns	(revision 1186)
@@ -0,0 +1,144 @@
+#!/usr/bin/python
+from twisted.internet import reactor
+from twisted.names import server
+from twisted.names import dns
+from twisted.names import common
+from twisted.internet import defer
+from twisted.python import failure
+
+from invirt.config import structs as config
+import invirt.database
+import psycopg2
+import sqlalchemy
+import time
+
+class DatabaseAuthority(common.ResolverBase):
+    """An Authority that is loaded from a file."""
+
+    soa = None
+
+    def __init__(self, domains=None, database=None):
+        common.ResolverBase.__init__(self)
+        if database is not None:
+            invirt.database.connect(database)
+        else:
+            invirt.database.connect()
+        if domains is not None:
+            self.domains = domains
+        else:
+            self.domains = config.dns.domains
+        ns = config.dns.nameservers[0]
+        self.soa = dns.Record_SOA(mname=ns.hostname,
+                                  rname=config.dns.contact.replace('@','.',1),
+                                  serial=1, refresh=3600, retry=900,
+                                  expire=3600000, minimum=21600, ttl=3600)
+        self.ns = dns.Record_NS(name=ns.hostname, ttl=3600)
+        record = dns.Record_A(address=ns.ip, ttl=3600)
+        self.ns1 = dns.RRHeader(ns.hostname, dns.A, dns.IN,
+                                3600, record, auth=True)
+
+    
+    def _lookup(self, name, cls, type, timeout = None):
+        for i in range(3):
+            try:
+                value = self._lookup_unsafe(name, cls, type, timeout = None)
+            except (psycopg2.OperationalError, sqlalchemy.exceptions.SQLError):
+                if i == 2:
+                    raise
+                print "Reloading database"
+                time.sleep(0.5)
+                continue
+            else:
+                return value
+
+    def _lookup_unsafe(self, name, cls, type, timeout):
+        invirt.database.clear_cache()
+        
+        ttl = 900
+        name = name.lower()
+
+        # XXX hack for the transition to two separate dev/prod clusters
+        if 'dev.xvm.mit.edu' in self.domains and name.endswith('prod.xvm.mit.edu'):
+            # import time, sys
+            # print time.localtime(), 'handling prod request', name
+            # sys.stdout.flush()
+
+            # Point the client in the right direction for prod requests.
+            authority = dns.RRHeader('prod.xvm.mit.edu', dns.NS, dns.IN, 3600,
+                    dns.Record_NS(name='ns1.prod.xvm.mit.edu', ttl=3600), auth=True)
+            additional = dns.RRHeader('ns1.prod.xvm.mit.edu', dns.A, dns.IN, 3600,
+                    dns.Record_A(address='18.181.0.221', ttl=3600), auth=True)
+            return defer.succeed(([], [authority], [additional]))
+
+        if name in self.domains:
+            domain = name
+        else:
+            # Look for the longest-matching domain.  (This works because domain
+            # will remain bound after breaking out of the loop.)
+            best_domain = ''
+            for domain in self.domains:
+                if name.endswith('.'+domain) and len(domain) > len(best_domain):
+                    best_domain = domain
+            if best_domain == '':
+                return defer.fail(failure.Failure(dns.DomainError(name)))
+            domain = best_domain
+        results = []
+        authority = []
+        additional = [self.ns1]
+        authority.append(dns.RRHeader(domain, dns.NS, dns.IN,
+                                      3600, self.ns, auth=True))
+
+        if cls == dns.IN:
+            host = name[:-len(domain)-1]
+            if not host: # Request for the domain itself.
+                if type in (dns.A, dns.ALL_RECORDS):
+                    record = dns.Record_A(config.dns.nameservers[0].ip, ttl)
+                    results.append(dns.RRHeader(name, dns.A, dns.IN, 
+                                                ttl, record, auth=True))
+                elif type == dns.NS:
+                    results.append(dns.RRHeader(domain, dns.NS, dns.IN,
+                                                ttl, self.ns, auth=True))
+                    authority = []
+                elif type == dns.SOA:
+                    results.append(dns.RRHeader(domain, dns.SOA, dns.IN,
+                                                ttl, self.soa, auth=True))
+            else: # Request for a subdomain.
+                if 'passup' in dir(config.dns) and host in config.dns.passup:
+                    record = dns.Record_CNAME('%s.%s' % (host, config.dns.parent), ttl)
+                    return defer.succeed((
+                        [dns.RRHeader(name, dns.CNAME, dns.IN, ttl, record, auth=True)],
+                        [], []))
+
+                value = invirt.database.Machine.query().filter_by(name=host).one()
+                if value is None or not value.nics:
+                    return defer.fail(failure.Failure(dns.AuthoritativeDomainError(name)))
+                ip = value.nics[0].ip
+                if ip is None:  #Deactivated?
+                    return defer.fail(failure.Failure(dns.AuthoritativeDomainError(name)))
+
+                if type in (dns.A, dns.ALL_RECORDS):
+                    record = dns.Record_A(ip, ttl)
+                    results.append(dns.RRHeader(name, dns.A, dns.IN, 
+                                                ttl, record, auth=True))
+                elif type == dns.SOA:
+                    results.append(dns.RRHeader(domain, dns.SOA, dns.IN,
+                                                ttl, self.soa, auth=True))
+            if len(results) == 0:
+                authority = []
+                additional = []
+            return defer.succeed((results, authority, additional))
+        else:
+            #Doesn't exist
+            return defer.fail(failure.Failure(dns.AuthoritativeDomainError(name)))
+
+if '__main__' == __name__:
+    resolver = DatabaseAuthority()
+
+    verbosity = 0
+    f = server.DNSServerFactory(authorities=[resolver], verbose=verbosity)
+    p = dns.DNSDatagramProtocol(f)
+    f.noisy = p.noisy = verbosity
+    
+    reactor.listenUDP(53, p)
+    reactor.listenTCP(53, f)
+    reactor.run()