Index: trunk/packages/invirt-console-host/debian/changelog
===================================================================
--- trunk/packages/sipb-xen-console-server/debian/changelog	(revision 1120)
+++ trunk/packages/invirt-console-host/debian/changelog	(revision 1187)
@@ -1,2 +1,9 @@
+invirt-console-host (0.0.1) unstable; urgency=low
+
+  * sipb-xen -> invirt
+  * -server -> -host while we're at it
+
+ -- Greg Price <price@mit.edu>  Fri, 24 Oct 2008 01:23:56 -0400
+
 sipb-xen-console-server (2.8) unstable; urgency=low
 
Index: trunk/packages/invirt-console-host/debian/control
===================================================================
--- trunk/packages/sipb-xen-console-server/debian/control	(revision 1120)
+++ trunk/packages/invirt-console-host/debian/control	(revision 1187)
@@ -1,10 +1,10 @@
-Source: sipb-xen-console-server
+Source: invirt-console-host
 Section: servers
 Priority: important
-Maintainer: sipb-xen@mit.edu
+Maintainer: invirt@mit.edu
 Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 5), config-package-dev (>= 4.5~)
 Standards-Version: 3.7.2
 
-Package: sipb-xen-console-server
+Package: invirt-console-host
 Architecture: all
 Provides: ${diverted-files}
Index: trunk/packages/invirt-console-host/debian/control.in
===================================================================
--- trunk/packages/sipb-xen-console-server/debian/control.in	(revision 1120)
+++ trunk/packages/invirt-console-host/debian/control.in	(revision 1187)
@@ -1,10 +1,10 @@
-Source: sipb-xen-console-server
+Source: invirt-console-host
 Section: servers
 Priority: important
-Maintainer: sipb-xen@mit.edu
+Maintainer: invirt@mit.edu
 Build-Depends: @cdbs@
 Standards-Version: 3.7.2
 
-Package: sipb-xen-console-server
+Package: invirt-console-host
 Architecture: all
 Provides: ${diverted-files}
Index: trunk/packages/invirt-console-host/debian/copyright
===================================================================
--- trunk/packages/sipb-xen-console-server/debian/copyright	(revision 1120)
+++ trunk/packages/invirt-console-host/debian/copyright	(revision 1187)
@@ -1,3 +1,3 @@
 This package was created for internal use of the SIPB Xen Project of
-the MIT Student Information Processing Board.  Ask sipb-xen@mit.edu if
+the MIT Student Information Processing Board.  Ask invirt@mit.edu if
 you have questions about redistribution.
Index: trunk/packages/invirt-console-host/debian/invirt-console-host.cron.d
===================================================================
--- trunk/packages/invirt-console-host/debian/invirt-console-host.cron.d	(revision 1187)
+++ trunk/packages/invirt-console-host/debian/invirt-console-host.cron.d	(revision 1187)
@@ -0,0 +1,8 @@
+#
+# cron-jobs for invirt-console-host
+# Refresh the list of active VM consoles
+#
+
+MAILTO=root
+
+*/5 * * * * root python /usr/sbin/invirt-update-conserver
Index: trunk/packages/invirt-console-host/debian/invirt-console-host.init
===================================================================
--- trunk/packages/invirt-console-host/debian/invirt-console-host.init	(revision 1187)
+++ trunk/packages/invirt-console-host/debian/invirt-console-host.init	(revision 1187)
@@ -0,0 +1,112 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides:          invirt-console-host
+# Required-Start:    $local_fs $remote_fs
+# Required-Stop:     $local_fs $remote_fs
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: conserver config from invirt config for invirt host
+# Description:       
+### END INIT INFO
+
+# Author: Invirt/XVM Project, MIT SIPB <invirt@mit.edu>
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="Invirt host console config"
+NAME=invirt-console-host
+SCRIPTNAME=/etc/init.d/$NAME
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+. /lib/lsb/init-functions
+
+gen_config()
+{
+        for i in /etc/conserver/invirt-genconfig.cf
+        do mako-render $i.mako > $i
+        done
+}
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+	# Return
+	#   0 if daemon has been started
+	#   1 if daemon was already running
+	#   2 if daemon could not be started
+	gen_config
+	VERBOSE=no /etc/init.d/conserver-server reload
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+	return 1
+}
+
+do_reload()
+{
+	gen_config
+	VERBOSE=no /etc/init.d/conserver-server reload
+}
+
+case "$1" in
+  start)
+	[ "$VERBOSE" != no ] && log_begin_msg "Starting $DESC" "$NAME"
+	do_start
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  stop)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+	do_stop
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  reload|force-reload)
+	log_daemon_msg "Reloading $DESC" "$NAME"
+	do_reload
+	log_end_msg $?
+	;;
+  restart)
+	log_daemon_msg "Restarting $DESC" "$NAME"
+	do_stop
+	case "$?" in
+	  0|1)
+		do_start
+		case "$?" in
+			0) log_end_msg 0 ;;
+			1) log_end_msg 1 ;; # Old process is still running
+			*) log_end_msg 1 ;; # Failed to start
+		esac
+		;;
+	  *)
+	  	# Failed to stop
+		log_end_msg 1
+		;;
+	esac
+	;;
+  *)
+	echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+	exit 3
+	;;
+esac
+
+:
Index: trunk/packages/invirt-console-host/debian/invirt-console-host.install
===================================================================
--- trunk/packages/invirt-console-host/debian/invirt-console-host.install	(revision 1187)
+++ trunk/packages/invirt-console-host/debian/invirt-console-host.install	(revision 1187)
@@ -0,0 +1,1 @@
+files/* .
Index: trunk/packages/invirt-console-host/debian/invirt-console-host.postinst
===================================================================
--- trunk/packages/invirt-console-host/debian/invirt-console-host.postinst	(revision 1187)
+++ trunk/packages/invirt-console-host/debian/invirt-console-host.postinst	(revision 1187)
@@ -0,0 +1,44 @@
+#!/bin/sh
+# postinst script for invirt-console-host
+#
+# see: dh_installdeb(1)
+
+set -e
+
+# summary of how this script can be called:
+#        * <postinst> `configure' <most-recently-configured-version>
+#        * <old-postinst> `abort-upgrade' <new version>
+#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
+#          <new-version>
+#        * <postinst> `abort-remove'
+#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
+#          <failed-install-package> <version> `removing'
+#          <conflicting-package> <version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+
+case "$1" in
+    configure)
+        cat >>/etc/sudoers <<EOF
+### BEGIN invirt-console-host
+conservr ALL=(ALL) NOPASSWD: /usr/sbin/xm console d_*
+### END invirt-console-host
+EOF
+    ;;
+
+    abort-upgrade|abort-remove|abort-deconfigure)
+    ;;
+
+    *)
+        echo "postinst called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
Index: trunk/packages/invirt-console-host/debian/invirt-console-host.prerm
===================================================================
--- trunk/packages/invirt-console-host/debian/invirt-console-host.prerm	(revision 1187)
+++ trunk/packages/invirt-console-host/debian/invirt-console-host.prerm	(revision 1187)
@@ -0,0 +1,39 @@
+#!/bin/sh
+# prerm script for invirt-console-host
+#
+# see: dh_installdeb(1)
+
+set -e
+
+# summary of how this script can be called:
+#        * <prerm> `remove'
+#        * <old-prerm> `upgrade' <new-version>
+#        * <new-prerm> `failed-upgrade' <old-version>
+#        * <conflictor's-prerm> `remove' `in-favour' <package> <new-version>
+#        * <deconfigured's-prerm> `deconfigure' `in-favour'
+#          <package-being-installed> <version> `removing'
+#          <conflicting-package> <version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+
+case "$1" in
+    remove|upgrade|deconfigure)
+        perl -i.bak -ne 's%^### (BEGIN|END) invirt-console-host\s*$%%m && ($skip = ($1 eq "BEGIN")); print unless $skip;' /etc/sudoers
+    ;;
+
+    failed-upgrade)
+    ;;
+
+    *)
+        echo "prerm called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
Index: trunk/packages/invirt-console-host/debian/rules
===================================================================
--- trunk/packages/sipb-xen-console-server/debian/rules	(revision 1120)
+++ trunk/packages/invirt-console-host/debian/rules	(revision 1187)
@@ -2,8 +2,8 @@
 
 DEB_AUTO_UPDATE_DEBIAN_CONTROL = 1
-DEB_DIVERT_EXTENSION = .sipb-xen
-DEB_DIVERT_FILES_sipb-xen-console-server += \
-	/etc/conserver/conserver.cf.sipb-xen \
-	/etc/conserver/server.conf.sipb-xen
+DEB_DIVERT_EXTENSION = .invirt
+DEB_DIVERT_FILES_invirt-console-host += \
+	/etc/conserver/conserver.cf.invirt \
+	/etc/conserver/server.conf.invirt
 
 include /usr/share/cdbs/1/rules/debhelper.mk
Index: trunk/packages/invirt-console-host/debian/sipb-xen-console-server.cron.d
===================================================================
--- trunk/packages/sipb-xen-console-server/debian/sipb-xen-console-server.cron.d	(revision 1120)
+++ 	(revision )
@@ -1,8 +1,0 @@
-#
-# cron-jobs for sipb-xen-console-server
-# Refresh the list of active VM consoles
-#
-
-MAILTO=root
-
-*/5 * * * * root python /usr/sbin/sipb-xen-update-conserver
Index: trunk/packages/invirt-console-host/debian/sipb-xen-console-server.init
===================================================================
--- trunk/packages/sipb-xen-console-server/debian/sipb-xen-console-server.init	(revision 1120)
+++ 	(revision )
@@ -1,112 +1,0 @@
-#! /bin/sh
-### BEGIN INIT INFO
-# Provides:          sipb-xen-console-server
-# Required-Start:    $local_fs $remote_fs
-# Required-Stop:     $local_fs $remote_fs
-# Default-Start:     2 3 4 5
-# Default-Stop:      0 1 6
-# Short-Description: conserver config from invirt config for invirt host
-# Description:       
-### END INIT INFO
-
-# Author: Invirt/XVM Project, MIT SIPB <invirt@mit.edu>
-
-# Do NOT "set -e"
-
-# PATH should only include /usr/* if it runs after the mountnfs.sh script
-PATH=/sbin:/usr/sbin:/bin:/usr/bin
-DESC="Invirt host console config"
-NAME=sipb-xen-console-server
-SCRIPTNAME=/etc/init.d/$NAME
-
-# Read configuration variable file if it is present
-[ -r /etc/default/$NAME ] && . /etc/default/$NAME
-
-# Load the VERBOSE setting and other rcS variables
-. /lib/init/vars.sh
-
-# Define LSB log_* functions.
-# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
-. /lib/lsb/init-functions
-
-gen_config()
-{
-        for i in /etc/conserver/invirt-genconfig.cf
-        do mako-render $i.mako > $i
-        done
-}
-
-#
-# Function that starts the daemon/service
-#
-do_start()
-{
-	# Return
-	#   0 if daemon has been started
-	#   1 if daemon was already running
-	#   2 if daemon could not be started
-	gen_config
-	VERBOSE=no /etc/init.d/conserver-server reload
-}
-
-#
-# Function that stops the daemon/service
-#
-do_stop()
-{
-	return 1
-}
-
-do_reload()
-{
-	gen_config
-	VERBOSE=no /etc/init.d/conserver-server reload
-}
-
-case "$1" in
-  start)
-	[ "$VERBOSE" != no ] && log_begin_msg "Starting $DESC" "$NAME"
-	do_start
-	case "$?" in
-		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-	esac
-	;;
-  stop)
-	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
-	do_stop
-	case "$?" in
-		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-	esac
-	;;
-  reload|force-reload)
-	log_daemon_msg "Reloading $DESC" "$NAME"
-	do_reload
-	log_end_msg $?
-	;;
-  restart)
-	log_daemon_msg "Restarting $DESC" "$NAME"
-	do_stop
-	case "$?" in
-	  0|1)
-		do_start
-		case "$?" in
-			0) log_end_msg 0 ;;
-			1) log_end_msg 1 ;; # Old process is still running
-			*) log_end_msg 1 ;; # Failed to start
-		esac
-		;;
-	  *)
-	  	# Failed to stop
-		log_end_msg 1
-		;;
-	esac
-	;;
-  *)
-	echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
-	exit 3
-	;;
-esac
-
-:
Index: trunk/packages/invirt-console-host/debian/sipb-xen-console-server.install
===================================================================
--- trunk/packages/sipb-xen-console-server/debian/sipb-xen-console-server.install	(revision 1120)
+++ 	(revision )
@@ -1,1 +1,0 @@
-files/* .
Index: trunk/packages/invirt-console-host/debian/sipb-xen-console-server.postinst
===================================================================
--- trunk/packages/sipb-xen-console-server/debian/sipb-xen-console-server.postinst	(revision 1120)
+++ 	(revision )
@@ -1,44 +1,0 @@
-#!/bin/sh
-# postinst script for sipb-xen-console-server
-#
-# see: dh_installdeb(1)
-
-set -e
-
-# summary of how this script can be called:
-#        * <postinst> `configure' <most-recently-configured-version>
-#        * <old-postinst> `abort-upgrade' <new version>
-#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
-#          <new-version>
-#        * <postinst> `abort-remove'
-#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
-#          <failed-install-package> <version> `removing'
-#          <conflicting-package> <version>
-# for details, see http://www.debian.org/doc/debian-policy/ or
-# the debian-policy package
-
-
-case "$1" in
-    configure)
-        cat >>/etc/sudoers <<EOF
-### BEGIN sipb-xen-console-server
-conservr ALL=(ALL) NOPASSWD: /usr/sbin/xm console d_*
-### END sipb-xen-console-server
-EOF
-    ;;
-
-    abort-upgrade|abort-remove|abort-deconfigure)
-    ;;
-
-    *)
-        echo "postinst called with unknown argument \`$1'" >&2
-        exit 1
-    ;;
-esac
-
-# dh_installdeb will replace this with shell code automatically
-# generated by other debhelper scripts.
-
-#DEBHELPER#
-
-exit 0
Index: trunk/packages/invirt-console-host/debian/sipb-xen-console-server.prerm
===================================================================
--- trunk/packages/sipb-xen-console-server/debian/sipb-xen-console-server.prerm	(revision 1120)
+++ 	(revision )
@@ -1,39 +1,0 @@
-#!/bin/sh
-# prerm script for sipb-xen-console-server
-#
-# see: dh_installdeb(1)
-
-set -e
-
-# summary of how this script can be called:
-#        * <prerm> `remove'
-#        * <old-prerm> `upgrade' <new-version>
-#        * <new-prerm> `failed-upgrade' <old-version>
-#        * <conflictor's-prerm> `remove' `in-favour' <package> <new-version>
-#        * <deconfigured's-prerm> `deconfigure' `in-favour'
-#          <package-being-installed> <version> `removing'
-#          <conflicting-package> <version>
-# for details, see http://www.debian.org/doc/debian-policy/ or
-# the debian-policy package
-
-
-case "$1" in
-    remove|upgrade|deconfigure)
-        perl -i.bak -ne 's%^### (BEGIN|END) sipb-xen-console-server\s*$%%m && ($skip = ($1 eq "BEGIN")); print unless $skip;' /etc/sudoers
-    ;;
-
-    failed-upgrade)
-    ;;
-
-    *)
-        echo "prerm called with unknown argument \`$1'" >&2
-        exit 1
-    ;;
-esac
-
-# dh_installdeb will replace this with shell code automatically
-# generated by other debhelper scripts.
-
-#DEBHELPER#
-
-exit 0