Index: trunk/packages/sipb-xen-python-pydhcplib/debian/changelog
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/changelog	(revision 1039)
+++ 	(revision )
@@ -1,19 +1,0 @@
-sipb-xen-python-pydhcplib (0.3.2-3) unstable; urgency=low
-
-  * Explicitly require Python 2.5
-  * Cleanup the copyright file a bit
-
- -- Evan Broder <broder@mit.edu>  Sat, 04 Oct 2008 20:23:52 -0400
-
-sipb-xen-python-pydhcplib (0.3.2-2) unstable; urgency=low
-
-  * Add a patch to allow DHCP option 119 (domain-search) to work
-
- -- SIPB Xen Project <sipb-xen@mit.edu>  Mon, 31 Mar 2008 19:33:13 -0400
-
-sipb-xen-python-pydhcplib (0.3.2-1) unstable; urgency=low
-
-  * Initial release.
-
- -- SIPB Xen Project <sipb-xen@mit.edu>  Sun, 30 Mar 2008 16:03:05 -0400
-
Index: trunk/packages/sipb-xen-python-pydhcplib/debian/compat
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/compat	(revision 1039)
+++ 	(revision )
@@ -1,1 +1,0 @@
-5
Index: trunk/packages/sipb-xen-python-pydhcplib/debian/control
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/control	(revision 1039)
+++ 	(revision )
@@ -1,12 +1,0 @@
-Source: sipb-xen-python-pydhcplib
-Section: python
-Priority: extra
-Maintainer: SIPB Xen Project <sipb-xen@mit.edu>
-Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 5), quilt, patchutils (>= 0.2.25), cdbs (>= 0.4.27-1), debhelper (>= 5.0.37.2), cdbs (>= 0.4.43), python-all-dev (>= 2.3.5-11), python-support (>= 0.3.2)
-Standards-Version: 3.7.2
-
-Package: sipb-xen-python-pydhcplib
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
-Provides: ${python:Provides}
-Description: A pure Python library for handling DHCP packets and requests
Index: trunk/packages/sipb-xen-python-pydhcplib/debian/control.in
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/control.in	(revision 1039)
+++ 	(revision )
@@ -1,12 +1,0 @@
-Source: sipb-xen-python-pydhcplib
-Section: python
-Priority: extra
-Maintainer: SIPB Xen Project <sipb-xen@mit.edu>
-Build-Depends: @cdbs@
-Standards-Version: 3.7.2
-
-Package: sipb-xen-python-pydhcplib
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
-Provides: ${python:Provides}
-Description: A pure Python library for handling DHCP packets and requests
Index: trunk/packages/sipb-xen-python-pydhcplib/debian/copyright
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/copyright	(revision 1039)
+++ 	(revision )
@@ -1,31 +1,0 @@
-This package was debianized by the SIPB Xen Project <sipb-xen@mit.edu>
-on Sun, 30 Mar 2008 16:40:21 -0400.
-
-It was downloaded from http://pydhcplib.tuxfamily.org/download/
-
-Upstream Author: 
-
-    Mathieu Ignacio <mignacio@april.org>
-
-Copyright: 
-
-    Copyright (C) 2005 Mathieu Ignacio -- mignacio@april.org
-
-License:
-
-    This program is free software; you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
-    the Free Software Foundation; either version 2 of the License, or
-    (at your option) any later version.
-    
-    This program is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU General Public License for more details.
-    
-    You should have received a copy of the GNU General Public License
-    along with this package; if not, write to the Free Software
-    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
-
-On Debian systems, the complete text of the GNU General
-Public License can be found in `/usr/share/common-licenses/GPL'.
Index: trunk/packages/sipb-xen-python-pydhcplib/debian/docs
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/docs	(revision 1039)
+++ 	(revision )
@@ -1,1 +1,0 @@
-README
Index: trunk/packages/sipb-xen-python-pydhcplib/debian/patches/non-standard-options.patch
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/patches/non-standard-options.patch	(revision 1039)
+++ 	(revision )
@@ -1,16 +1,0 @@
-Index: pydhcplib/dhcp_basic_packet.py
-===================================================================
---- sipb-xen-python-pydhcp/pydhcplib/dhcp_basic_packet.py
-+++ sipb-xen-python-pydhcp/pydhcplib/dhcp_basic_packet.py
-@@ -99,9 +99,9 @@
-                              "char":[1,0,1], "16-bits":[2,0,1],
-                              "32-bits":[4,0,1], "identifier":[0,2,1]}
-             
--            specs = fields_specs[DhcpOptionsTypes[DhcpOptions[name]]]
-+            specs = fields_specs.get(DhcpOptionsTypes[DhcpOptions[name]], [])
-             length = len(value)
--            if (specs[0]!=0 and specs==length) or (specs[1]<=length and length%specs[2]==0):
-+            if specs == [] or (specs[0]!=0 and specs==length) or (specs[1]<=length and length%specs[2]==0):
-                 self.options_data[name] = value
-                 return True
-             else :
Index: trunk/packages/sipb-xen-python-pydhcplib/debian/patches/series
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/patches/series	(revision 1039)
+++ 	(revision )
@@ -1,1 +1,0 @@
-non-standard-options.patch
Index: trunk/packages/sipb-xen-python-pydhcplib/debian/pycompat
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/pycompat	(revision 1039)
+++ 	(revision )
@@ -1,1 +1,0 @@
-2
Index: trunk/packages/sipb-xen-python-pydhcplib/debian/pyversions
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/pyversions	(revision 1039)
+++ 	(revision )
@@ -1,1 +1,0 @@
-2.5-
Index: trunk/packages/sipb-xen-python-pydhcplib/debian/rules
===================================================================
--- trunk/packages/sipb-xen-python-pydhcplib/debian/rules	(revision 1039)
+++ 	(revision )
@@ -1,8 +1,0 @@
-#!/usr/bin/make -f
-
-DEB_AUTO_UPDATE_DEBIAN_CONTROL=1
-DEB_PYTHON_SYSTEM=pysupport
-
-include /usr/share/cdbs/1/rules/debhelper.mk
-include /usr/share/cdbs/1/rules/patchsys-quilt.mk
-include /usr/share/cdbs/1/class/python-distutils.mk