Index: trunk/packages/sipb-xen-console/debian/changelog
===================================================================
--- trunk/packages/sipb-xen-console/debian/changelog	(revision 1121)
+++ trunk/packages/sipb-xen-console/debian/changelog	(revision 1200)
@@ -1,2 +1,9 @@
+invirt-console-server (0.0.1) unstable; urgency=low
+
+  * sipb-xen -> invirt
+  *  -> -server while we're at it
+
+ -- Greg Price <price@mit.edu>  Fri, 24 Oct 2008 03:54:40 -0400
+
 sipb-xen-console (8.4) unstable; urgency=low
 
Index: trunk/packages/sipb-xen-console/debian/control
===================================================================
--- trunk/packages/sipb-xen-console/debian/control	(revision 1121)
+++ trunk/packages/sipb-xen-console/debian/control	(revision 1200)
@@ -1,15 +1,14 @@
-Source: sipb-xen-console
+Source: invirt-console-server
 Section: servers
 Priority: extra
-Maintainer: SIPB Xen Project <sipb-xen@mit.edu>
+Maintainer: Invirt Project <invirt@mit.edu>
 Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 5), config-package-dev (>= 4.5~), nscd, openssh-server, debathena-ssh-server-config, initscripts
 Standards-Version: 3.7.2
 
-Package: sipb-xen-console
+Package: invirt-console-server
 Architecture: all
 Provides: ${diverted-files}
 Conflicts: ${diverted-files}
 Depends: sipb-xen-base, ${shlibs:Depends}, ${misc:Depends}, conserver-client, daemon, debathena-kerberos-config, fuse-utils, libnss-pgsql1, nscd, openssh-server, python, python-routefs, sipb-xen-chrony-config, sipb-xen-database-common, remctl-server, debathena-ssh-server-config
-Description: SIPB Xen serial console server
- This package  should be installed on sipb-xen-console
- It makes sure that necessary tools are available.
+Description: Invirt serial-console proxy server
+ This is the software for the serial-console proxy server.
Index: trunk/packages/sipb-xen-console/debian/copyright
===================================================================
--- trunk/packages/sipb-xen-console/debian/copyright	(revision 1121)
+++ trunk/packages/sipb-xen-console/debian/copyright	(revision 1200)
@@ -1,3 +1,3 @@
 This package was created for internal use of the SIPB Xen Project of
-the MIT Student Information Processing Board.  Ask sipb-xen@mit.edu if
+the MIT Student Information Processing Board.  Ask invirt@mit.edu if
 you have questions about redistribution.
Index: trunk/packages/sipb-xen-console/debian/invirt-console-server.init
===================================================================
--- trunk/packages/sipb-xen-console/debian/invirt-console-server.init	(revision 1200)
+++ trunk/packages/sipb-xen-console/debian/invirt-console-server.init	(revision 1200)
@@ -0,0 +1,135 @@
+#!/bin/bash
+### BEGIN INIT INFO
+# Provides:          invirt-console-server
+# Required-Start:    $local_fs $remote_fs
+# Required-Stop:     $local_fs $remote_fs
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Invirt console proxy server
+# Description:       
+### END INIT INFO
+
+# Author: Invirt Project <invirt@mit.edu>
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="the Invirt console server"
+NAME=invirt-console-server
+DAEMON=/usr/bin/invirt-consolefs
+DAEMON_ARGS="/consolefs"
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+. /lib/lsb/init-functions
+
+gen_config()
+{
+    for i in /etc/conserver/invirt-hosts.cf \
+             /etc/remctl/acl/invirt-console-server \
+             /etc/issue.net.no_tkt \
+             /etc/nss-pgsql.conf \
+             ; do
+        mako-render $i.mako > $i
+    done
+}
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+	# Return
+	#   0 if daemon has been started
+	#   1 if daemon was already running
+	#   2 if daemon could not be started
+	modprobe fuse
+	gen_config
+	daemon --running -n $NAME && return 1
+	daemon -r -O daemon.info -E daemon.err -n $NAME -U $DAEMON $DAEMON_ARGS || return 2
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+	# Return
+	#   0 if daemon has been stopped
+	#   1 if daemon was already stopped
+	#   2 if daemon could not be stopped
+	#   other if a failure occurred
+	daemon --stop -n $NAME
+	RETVAL="$?"
+	[ "$RETVAL" = 2 ] && return 2
+	# Many daemons don't delete their pidfiles when they exit.
+	rm -f $PIDFILE
+	umount "$DAEMON_ARGS"
+	return "$RETVAL"
+}
+
+do_reload()
+{
+	gen_config
+	/etc/init.d/conserver-server reload
+}
+
+case "$1" in
+  start)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+	do_start
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  stop)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+	do_stop
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  reload|force-reload)
+	log_daemon_msg "Reloading $DESC" "$NAME"
+	do_reload
+	log_end_msg $?
+	;;
+  restart)
+	log_daemon_msg "Restarting $DESC" "$NAME"
+	do_stop
+	case "$?" in
+	  0|1)
+		do_start
+		case "$?" in
+			0) log_end_msg 0 ;;
+			1) log_end_msg 1 ;; # Old process is still running
+			*) log_end_msg 1 ;; # Failed to start
+		esac
+		;;
+	  *)
+	  	# Failed to stop
+		log_end_msg 1
+		;;
+	esac
+	;;
+  *)
+	echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+	exit 3
+	;;
+esac
+
+:
Index: trunk/packages/sipb-xen-console/debian/invirt-console-server.install
===================================================================
--- trunk/packages/sipb-xen-console/debian/invirt-console-server.install	(revision 1200)
+++ trunk/packages/sipb-xen-console/debian/invirt-console-server.install	(revision 1200)
@@ -0,0 +1,1 @@
+files/* .
Index: trunk/packages/sipb-xen-console/debian/rules
===================================================================
--- trunk/packages/sipb-xen-console/debian/rules	(revision 1121)
+++ trunk/packages/sipb-xen-console/debian/rules	(revision 1200)
@@ -1,20 +1,20 @@
 #!/usr/bin/make -f
 
-DEB_DIVERT_EXTENSION = .sipb-xen
-DEB_TRANSFORM_FILES_sipb-xen-console += \
-	/etc/init.d/bootmisc.sh.sipb-xen \
-	/etc/nsswitch.conf.sipb-xen \
-	/etc/nscd.conf.sipb-xen \
-	/etc/pam.d/sshd.sipb-xen \
-	/etc/ssh/sshd_config.debathena.sipb-xen
+DEB_DIVERT_EXTENSION = .invirt
+DEB_TRANSFORM_FILES_invirt-console-server += \
+	/etc/init.d/bootmisc.sh.invirt \
+	/etc/nsswitch.conf.invirt \
+	/etc/nscd.conf.invirt \
+	/etc/pam.d/sshd.invirt \
+	/etc/ssh/sshd_config.debathena.invirt
 
 ifneq ($(wildcard /usr/share/base-files/nsswitch.conf),)
-    DEB_CHECK_FILES_SOURCE_/etc/nsswitch.conf.sipb-xen = \
+    DEB_CHECK_FILES_SOURCE_/etc/nsswitch.conf.invirt = \
         /usr/share/base-files/nsswitch.conf
 endif
 
-DEB_DIVERT_FILES_sipb-xen-console += \
-	/etc/conserver/conserver.cf.sipb-xen \
-	/etc/motd.sipb-xen
+DEB_DIVERT_FILES_invirt-console-server += \
+	/etc/conserver/conserver.cf.invirt \
+	/etc/motd.invirt
 
 include /usr/share/cdbs/1/rules/debhelper.mk
Index: trunk/packages/sipb-xen-console/debian/sipb-xen-console.init
===================================================================
--- trunk/packages/sipb-xen-console/debian/sipb-xen-console.init	(revision 1121)
+++ 	(revision )
@@ -1,135 +1,0 @@
-#!/bin/bash
-### BEGIN INIT INFO
-# Provides:          sipb-xen-console
-# Required-Start:    $local_fs $remote_fs
-# Required-Stop:     $local_fs $remote_fs
-# Default-Start:     2 3 4 5
-# Default-Stop:      0 1 6
-# Short-Description: sipb-xen Console Server homedir filesystem
-# Description:       
-### END INIT INFO
-
-# Author: SIPB Xen Project <sipb-xen@mit.edu>
-
-# Do NOT "set -e"
-
-# PATH should only include /usr/* if it runs after the mountnfs.sh script
-PATH=/sbin:/usr/sbin:/bin:/usr/bin
-DESC="The sipb-xen console server"
-NAME=sipb-xen-console
-DAEMON=/usr/bin/sipb-xen-consolefs
-DAEMON_ARGS="/consolefs"
-PIDFILE=/var/run/$NAME.pid
-SCRIPTNAME=/etc/init.d/$NAME
-
-# Exit if the package is not installed
-[ -x "$DAEMON" ] || exit 0
-
-# Read configuration variable file if it is present
-[ -r /etc/default/$NAME ] && . /etc/default/$NAME
-
-# Load the VERBOSE setting and other rcS variables
-. /lib/init/vars.sh
-
-# Define LSB log_* functions.
-# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
-. /lib/lsb/init-functions
-
-gen_config()
-{
-    for i in /etc/conserver/invirt-hosts.cf \
-             /etc/remctl/acl/invirt-console \
-             /etc/issue.net.no_tkt \
-             /etc/nss-pgsql.conf \
-             ; do
-        mako-render $i.mako > $i
-    done
-}
-
-#
-# Function that starts the daemon/service
-#
-do_start()
-{
-	# Return
-	#   0 if daemon has been started
-	#   1 if daemon was already running
-	#   2 if daemon could not be started
-	modprobe fuse
-	gen_config
-	daemon --running -n $NAME && return 1
-	daemon -r -O daemon.info -E daemon.err -n $NAME -U $DAEMON $DAEMON_ARGS || return 2
-}
-
-#
-# Function that stops the daemon/service
-#
-do_stop()
-{
-	# Return
-	#   0 if daemon has been stopped
-	#   1 if daemon was already stopped
-	#   2 if daemon could not be stopped
-	#   other if a failure occurred
-	daemon --stop -n $NAME
-	RETVAL="$?"
-	[ "$RETVAL" = 2 ] && return 2
-	# Many daemons don't delete their pidfiles when they exit.
-	rm -f $PIDFILE
-	umount "$DAEMON_ARGS"
-	return "$RETVAL"
-}
-
-do_reload()
-{
-	gen_config
-	/etc/init.d/conserver-server reload
-}
-
-case "$1" in
-  start)
-	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
-	do_start
-	case "$?" in
-		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-	esac
-	;;
-  stop)
-	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
-	do_stop
-	case "$?" in
-		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-	esac
-	;;
-  reload|force-reload)
-	log_daemon_msg "Reloading $DESC" "$NAME"
-	do_reload
-	log_end_msg $?
-	;;
-  restart)
-	log_daemon_msg "Restarting $DESC" "$NAME"
-	do_stop
-	case "$?" in
-	  0|1)
-		do_start
-		case "$?" in
-			0) log_end_msg 0 ;;
-			1) log_end_msg 1 ;; # Old process is still running
-			*) log_end_msg 1 ;; # Failed to start
-		esac
-		;;
-	  *)
-	  	# Failed to stop
-		log_end_msg 1
-		;;
-	esac
-	;;
-  *)
-	echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
-	exit 3
-	;;
-esac
-
-:
Index: trunk/packages/sipb-xen-console/debian/sipb-xen-console.install
===================================================================
--- trunk/packages/sipb-xen-console/debian/sipb-xen-console.install	(revision 1121)
+++ 	(revision )
@@ -1,1 +1,0 @@
-files/* .
Index: trunk/packages/sipb-xen-console/debian/transform_bootmisc.sh.invirt
===================================================================
--- trunk/packages/sipb-xen-console/debian/transform_bootmisc.sh.invirt	(revision 1200)
+++ trunk/packages/sipb-xen-console/debian/transform_bootmisc.sh.invirt	(revision 1200)
@@ -0,0 +1,14 @@
+#!/bin/bash
+patch -p0 -o /dev/fd/4 3<&0 4>&1 1>/dev/null <<EOF
+
+# Yes, I there's no context. But the lines being replaced are less
+# likely to change than the lines around them
+
+--- Ignored
++++ /dev/fd/3
+@@ -42,3 +42,2 @@
+-	# Update motd
+-	uname -snrvm > /var/run/motd
+-	[ -f /etc/motd.tail ] && cat /etc/motd.tail >> /var/run/motd
++	# Do not update motd
++	cp /etc/motd /var/run/motd
Index: trunk/packages/sipb-xen-console/debian/transform_bootmisc.sh.sipb-xen
===================================================================
--- trunk/packages/sipb-xen-console/debian/transform_bootmisc.sh.sipb-xen	(revision 1121)
+++ 	(revision )
@@ -1,14 +1,0 @@
-#!/bin/bash
-patch -p0 -o /dev/fd/4 3<&0 4>&1 1>/dev/null <<EOF
-
-# Yes, I there's no context. But the lines being replaced are less
-# likely to change than the lines around them
-
---- Ignored
-+++ /dev/fd/3
-@@ -42,3 +42,2 @@
--	# Update motd
--	uname -snrvm > /var/run/motd
--	[ -f /etc/motd.tail ] && cat /etc/motd.tail >> /var/run/motd
-+	# Do not update motd
-+	cp /etc/motd /var/run/motd
Index: trunk/packages/sipb-xen-console/debian/transform_nscd.conf.invirt
===================================================================
--- trunk/packages/sipb-xen-console/debian/transform_nscd.conf.invirt	(revision 1200)
+++ trunk/packages/sipb-xen-console/debian/transform_nscd.conf.invirt	(revision 1200)
@@ -0,0 +1,6 @@
+#!/usr/bin/perl -0p
+s/^(\s*negative-time-to-live\s*passwd\s*).*$/${1}3/m or die;
+s/^(\s*negative-time-to-live\s*group\s*).*$/${1}3/m or die;
+s/^(\s*persistent\s*passwd\s*).*$/\1no/m or die;
+s/^(\s*persistent\s*group\s*).*$/\1no/m or die;
+
Index: trunk/packages/sipb-xen-console/debian/transform_nscd.conf.sipb-xen
===================================================================
--- trunk/packages/sipb-xen-console/debian/transform_nscd.conf.sipb-xen	(revision 1121)
+++ 	(revision )
@@ -1,6 +1,0 @@
-#!/usr/bin/perl -0p
-s/^(\s*negative-time-to-live\s*passwd\s*).*$/${1}3/m or die;
-s/^(\s*negative-time-to-live\s*group\s*).*$/${1}3/m or die;
-s/^(\s*persistent\s*passwd\s*).*$/\1no/m or die;
-s/^(\s*persistent\s*group\s*).*$/\1no/m or die;
-
Index: trunk/packages/sipb-xen-console/debian/transform_nsswitch.conf.invirt
===================================================================
--- trunk/packages/sipb-xen-console/debian/transform_nsswitch.conf.invirt	(revision 1200)
+++ trunk/packages/sipb-xen-console/debian/transform_nsswitch.conf.invirt	(revision 1200)
@@ -0,0 +1,3 @@
+#!/usr/bin/perl -0p
+s/^(passwd: .*)$/$1 pgsql/m or die;
+s/^(group: .*)$/$1 pgsql/m or die;
Index: trunk/packages/sipb-xen-console/debian/transform_nsswitch.conf.sipb-xen
===================================================================
--- trunk/packages/sipb-xen-console/debian/transform_nsswitch.conf.sipb-xen	(revision 1121)
+++ 	(revision )
@@ -1,3 +1,0 @@
-#!/usr/bin/perl -0p
-s/^(passwd: .*)$/$1 pgsql/m or die;
-s/^(group: .*)$/$1 pgsql/m or die;
Index: trunk/packages/sipb-xen-console/debian/transform_sshd.invirt
===================================================================
--- trunk/packages/sipb-xen-console/debian/transform_sshd.invirt	(revision 1200)
+++ trunk/packages/sipb-xen-console/debian/transform_sshd.invirt	(revision 1200)
@@ -0,0 +1,11 @@
+#!/bin/sh
+echo "# If they're not root, but their user exists (success),"
+echo 'auth    [success=ignore ignore=ignore default=1 module_unknown=die]   pam_succeed_if.so uid > 0'
+echo "# print the \"You don\'t have tickets\" error:"
+echo 'auth    [success=die ignore=reset default=die module_unknown=die]     pam_echo.so file=/etc/issue.net.no_tkt'
+echo "# If !(they are root),"
+echo 'auth    [success=1 ignore=ignore default=ignore module_unknown=die]   pam_succeed_if.so uid eq 0'
+echo "# print the \"your account doesn't exist\" error:"
+echo 'auth    [success=die ignore=reset default=die module_unknown=die]     pam_echo.so file=/etc/issue.net.no_user'
+echo
+exec cat
Index: trunk/packages/sipb-xen-console/debian/transform_sshd.sipb-xen
===================================================================
--- trunk/packages/sipb-xen-console/debian/transform_sshd.sipb-xen	(revision 1121)
+++ 	(revision )
@@ -1,11 +1,0 @@
-#!/bin/sh
-echo "# If they're not root, but their user exists (success),"
-echo 'auth    [success=ignore ignore=ignore default=1 module_unknown=die]   pam_succeed_if.so uid > 0'
-echo "# print the \"You don\'t have tickets\" error:"
-echo 'auth    [success=die ignore=reset default=die module_unknown=die]     pam_echo.so file=/etc/issue.net.no_tkt'
-echo "# If !(they are root),"
-echo 'auth    [success=1 ignore=ignore default=ignore module_unknown=die]   pam_succeed_if.so uid eq 0'
-echo "# print the \"your account doesn't exist\" error:"
-echo 'auth    [success=die ignore=reset default=die module_unknown=die]     pam_echo.so file=/etc/issue.net.no_user'
-echo
-exec cat
Index: trunk/packages/sipb-xen-console/debian/transform_sshd_config.debathena.invirt
===================================================================
--- trunk/packages/sipb-xen-console/debian/transform_sshd_config.debathena.invirt	(revision 1200)
+++ trunk/packages/sipb-xen-console/debian/transform_sshd_config.debathena.invirt	(revision 1200)
@@ -0,0 +1,2 @@
+#!/usr/bin/perl -0p
+s/^#?PrintLastLog .*$/PrintLastLog no/m or die;
Index: trunk/packages/sipb-xen-console/debian/transform_sshd_config.debathena.sipb-xen
===================================================================
--- trunk/packages/sipb-xen-console/debian/transform_sshd_config.debathena.sipb-xen	(revision 1121)
+++ 	(revision )
@@ -1,2 +1,0 @@
-#!/usr/bin/perl -0p
-s/^#?PrintLastLog .*$/PrintLastLog no/m or die;