Index: trunk/packages/invirt-console-server/files/etc/conserver/conserver.cf.invirt
===================================================================
--- trunk/packages/invirt-console-server/files/etc/conserver/conserver.cf.invirt	(revision 1201)
+++ trunk/packages/invirt-console-server/files/etc/conserver/conserver.cf.invirt	(revision 1201)
@@ -0,0 +1,23 @@
+# default config for console
+config * {
+	sslrequired yes;
+}
+# If no consoles are defined, as is the case when the host first boots
+# up, conserver will quit. This keeps it running.
+#
+# Should someone create a VM called dummy-console, their VM will
+# shadow over this one
+console dummy-console {
+        master localhost;
+        type noop;
+}
+
+default * {
+        type exec;
+}
+access * {
+        trusted 127.0.0.1;
+        limited *;
+}
+
+#include /etc/conserver/invirt-hosts.cf
Index: trunk/packages/invirt-console-server/files/etc/conserver/conserver.cf.sipb-xen
===================================================================
--- trunk/packages/sipb-xen-console/files/etc/conserver/conserver.cf.sipb-xen	(revision 1121)
+++ 	(revision )
@@ -1,23 +1,0 @@
-# default config for console
-config * {
-	sslrequired yes;
-}
-# If no consoles are defined, as is the case when the host first boots
-# up, conserver will quit. This keeps it running.
-#
-# Should someone create a VM called dummy-console, their VM will
-# shadow over this one
-console dummy-console {
-        master localhost;
-        type noop;
-}
-
-default * {
-        type exec;
-}
-access * {
-        trusted 127.0.0.1;
-        limited *;
-}
-
-#include /etc/conserver/invirt-hosts.cf
Index: trunk/packages/invirt-console-server/files/etc/motd.invirt
===================================================================
--- trunk/packages/invirt-console-server/files/etc/motd.invirt	(revision 1201)
+++ trunk/packages/invirt-console-server/files/etc/motd.invirt	(revision 1201)
@@ -0,0 +1,3 @@
+
+Type Ctrl-e, then c, then . to escape from the console
+
Index: trunk/packages/invirt-console-server/files/etc/motd.sipb-xen
===================================================================
--- trunk/packages/sipb-xen-console/files/etc/motd.sipb-xen	(revision 1121)
+++ 	(revision )
@@ -1,3 +1,0 @@
-
-Type Ctrl-e, then c, then . to escape from the console
-
Index: trunk/packages/invirt-console-server/files/etc/nss-pgsql.conf.mako
===================================================================
--- trunk/packages/sipb-xen-console/files/etc/nss-pgsql.conf.mako	(revision 1121)
+++ trunk/packages/invirt-console-server/files/etc/nss-pgsql.conf.mako	(revision 1201)
@@ -2,7 +2,7 @@
 connectionstring = host=${cfg.db.host} dbname=${cfg.db.dbname} user=${cfg.db.user} port=${cfg.db.port}
 
-getpwnam = SELECT name, NULL, name, '/consolefs/'|| name, '/usr/bin/sipb-xen-consolesh', machine_id + 1000, machine_id + 1000 FROM machines WHERE name = $1
-getpwuid = SELECT name, NULL, name, '/consolefs/'|| name, '/usr/bin/sipb-xen-consolesh', machine_id + 1000, machine_id + 1000 FROM machines WHERE machine_id + 1000 = $1
-allusers = SELECT name, NULL, name, '/consolefs/'|| name, '/usr/bin/sipb-xen-consolesh', machine_id + 1000, machine_id + 1000 FROM machines
+getpwnam = SELECT name, NULL, name, '/consolefs/'|| name, '/usr/bin/invirt-consolesh', machine_id + 1000, machine_id + 1000 FROM machines WHERE name = $1
+getpwuid = SELECT name, NULL, name, '/consolefs/'|| name, '/usr/bin/invirt-consolesh', machine_id + 1000, machine_id + 1000 FROM machines WHERE machine_id + 1000 = $1
+allusers = SELECT name, NULL, name, '/consolefs/'|| name, '/usr/bin/invirt-consolesh', machine_id + 1000, machine_id + 1000 FROM machines
 getgrnam = SELECT name, NULL, machine_id + 1000 FROM machines WHERE name = $1
 getgrgid = SELECT name, NULL, machine_id + 1000 FROM machines WHERE machine_id + 1000 = $1
Index: trunk/packages/invirt-console-server/files/etc/remctl/acl/invirt-console-server.mako
===================================================================
--- trunk/packages/invirt-console-server/files/etc/remctl/acl/invirt-console-server.mako	(revision 1201)
+++ trunk/packages/invirt-console-server/files/etc/remctl/acl/invirt-console-server.mako	(revision 1201)
@@ -0,0 +1,4 @@
+<% from invirt.config import structs as cfg %>\
+% for h in cfg.hosts:
+host/${h.hostname}@${cfg.authn[0].realm}
+% endfor
Index: trunk/packages/invirt-console-server/files/etc/remctl/acl/invirt-console.mako
===================================================================
--- trunk/packages/sipb-xen-console/files/etc/remctl/acl/invirt-console.mako	(revision 1121)
+++ 	(revision )
@@ -1,4 +1,0 @@
-<% from invirt.config import structs as cfg %>\
-% for h in cfg.hosts:
-host/${h.hostname}@${cfg.authn[0].realm}
-% endfor